/* Mathematiques de l'informatique graphique    */
/* Coordonnees homogenes en 3D                  */
/*                                              */
/* Mars 2021                                    */

#ifndef ____CH3D____
#define ____CH3D____

class TG3D;
class Pos3D;
class Dir3D;

class CH3D  {

  public :

    /* Coordonnees x, y et z                    */

    float x;
    float y;
    float z;

  private :

    /* Coordonnee w                             */

    float w;

  protected :

    /* Construit la position origine            */

    CH3D(void);

    /* Construit la CH3D (xp,yp,zp,wp)          */

    CH3D(float xp,float yp,float zp,float wp);

    /* Construit un clone de la CH3D ch         */

    CH3D(CH3D *ch);

    /* Destructeur                              */

    virtual ~CH3D(void);

  public :

    /* Methode d'affichage texte                */

    void print(void);
};

#endif
